/* tslint:disable */
/* eslint-disable */
/**
 * OpenAPI definition
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: v0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import * as runtime from '../runtime';
import {
  CountResponse,
  CountResponseFromJSON,
  CountResponseToJSON,
  PageTransactionMessage,
  PageTransactionMessageFromJSON,
  PageTransactionMessageToJSON,
  PageTransactionSummary,
  PageTransactionSummaryFromJSON,
  PageTransactionSummaryToJSON,
  ReferenceDataDto,
  ReferenceDataDtoFromJSON,
  ReferenceDataDtoToJSON,
  TransactionAllMetrics,
  TransactionAllMetricsFromJSON,
  TransactionAllMetricsToJSON,
  TransactionDto,
  TransactionDtoFromJSON,
  TransactionDtoToJSON,
  TransactionMessage,
  TransactionMessageFromJSON,
  TransactionMessageToJSON,
  TransactionReviewRequestBody,
  TransactionReviewRequestBodyFromJSON,
  TransactionReviewRequestBodyToJSON,
  TransactionsReviewRequestBody,
  TransactionsReviewRequestBodyFromJSON,
  TransactionsReviewRequestBodyToJSON,
  TransactionsReviewResponse,
  TransactionsReviewResponseFromJSON,
  TransactionsReviewResponseToJSON,
} from '../models';

export interface PacsTransactionsControllerImplApiFindRequest {
  filter?: string;
  pn?: number;
  ps?: number;
  sort?: string;
  direction?: FindDirectionEnum;
}

export interface PacsTransactionsControllerImplApiFindAllMessagesByTxIdRequest {
  transactionId: string;
}

export interface PacsTransactionsControllerImplApiFindByIdRequest {
  transactionId: string;
}

export interface PacsTransactionsControllerImplApiFindMessagesByTxIdRequest {
  transactionId: string;
  filter?: string;
  pn?: number;
  ps?: number;
  sort?: string;
  direction?: FindMessagesByTxIdDirectionEnum;
}

export interface PacsTransactionsControllerImplApiGetRawMessageByIdRequest {
  transactionMessageId: string;
}

export interface PacsTransactionsControllerImplApiReviewRequest {
  transactionId: string;
  transactionReviewRequestBody: TransactionReviewRequestBody;
}

export interface PacsTransactionsControllerImplApiReview1Request {
  transactionsReviewRequestBody: TransactionsReviewRequestBody;
}

/**
 *
 */
export class PacsTransactionsControllerImplApi extends runtime.BaseAPI {
  /**
   * Returns a transactions page
   * Find transactions
   */
  async findRaw(
    requestParameters: PacsTransactionsControllerImplApiFindRequest,
    initOverrides?: RequestInit | runtime.InitOverideFunction
  ): Promise<runtime.ApiResponse<PageTransactionSummary>> {
    const queryParameters: any = {};

    if (requestParameters.filter !== undefined) {
      queryParameters['filter'] = requestParameters.filter;
    }

    if (requestParameters.pn !== undefined) {
      queryParameters['pn'] = requestParameters.pn;
    }

    if (requestParameters.ps !== undefined) {
      queryParameters['ps'] = requestParameters.ps;
    }

    if (requestParameters.sort !== undefined) {
      queryParameters['sort'] = requestParameters.sort;
    }

    if (requestParameters.direction !== undefined) {
      queryParameters['direction'] = requestParameters.direction;
    }

    const headerParameters: runtime.HTTPHeaders = {};

    const response = await this.request(
      {
        path: `/api/gateway/iso20022/transactions`,
        method: 'GET',
        headers: headerParameters,
        query: queryParameters,
      },
      initOverrides
    );

    return new runtime.JSONApiResponse(response, (jsonValue) =>
      PageTransactionSummaryFromJSON(jsonValue)
    );
  }

  /**
   * Returns a transactions page
   * Find transactions
   */
  async find(
    requestParameters: PacsTransactionsControllerImplApiFindRequest = {},
    initOverrides?: RequestInit | runtime.InitOverideFunction
  ): Promise<PageTransactionSummary> {
    const response = await this.findRaw(requestParameters, initOverrides);
    return await response.value();
  }

  /**
   * Get all messages for the transaction matching the given ID
   * Get all messages for a transaction
   */
  async findAllMessagesByTxIdRaw(
    requestParameters: PacsTransactionsControllerImplApiFindAllMessagesByTxIdRequest,
    initOverrides?: RequestInit | runtime.InitOverideFunction
  ): Promise<runtime.ApiResponse<Array<TransactionMessage>>> {
    if (
      requestParameters.transactionId === null ||
      requestParameters.transactionId === undefined
    ) {
      throw new runtime.RequiredError(
        'transactionId',
        'Required parameter requestParameters.transactionId was null or undefined when calling findAllMessagesByTxId.'
      );
    }

    const queryParameters: any = {};

    const headerParameters: runtime.HTTPHeaders = {};

    const response = await this.request(
      {
        path: `/api/gateway/iso20022/transactions/{transactionId}/messages/all`.replace(
          `{${'transactionId'}}`,
          encodeURIComponent(String(requestParameters.transactionId))
        ),
        method: 'GET',
        headers: headerParameters,
        query: queryParameters,
      },
      initOverrides
    );

    return new runtime.JSONApiResponse(response, (jsonValue) =>
      jsonValue.map(TransactionMessageFromJSON)
    );
  }

  /**
   * Get all messages for the transaction matching the given ID
   * Get all messages for a transaction
   */
  async findAllMessagesByTxId(
    requestParameters: PacsTransactionsControllerImplApiFindAllMessagesByTxIdRequest,
    initOverrides?: RequestInit | runtime.InitOverideFunction
  ): Promise<Array<TransactionMessage>> {
    const response = await this.findAllMessagesByTxIdRaw(
      requestParameters,
      initOverrides
    );
    return await response.value();
  }

  /**
   * Returns a single transaction
   * Find transaction by ID
   */
  async findByIdRaw(
    requestParameters: PacsTransactionsControllerImplApiFindByIdRequest,
    initOverrides?: RequestInit | runtime.InitOverideFunction
  ): Promise<runtime.ApiResponse<TransactionDto>> {
    if (
      requestParameters.transactionId === null ||
      requestParameters.transactionId === undefined
    ) {
      throw new runtime.RequiredError(
        'transactionId',
        'Required parameter requestParameters.transactionId was null or undefined when calling findById.'
      );
    }

    const queryParameters: any = {};

    const headerParameters: runtime.HTTPHeaders = {};

    const response = await this.request(
      {
        path: `/api/gateway/iso20022/transactions/{transactionId}`.replace(
          `{${'transactionId'}}`,
          encodeURIComponent(String(requestParameters.transactionId))
        ),
        method: 'GET',
        headers: headerParameters,
        query: queryParameters,
      },
      initOverrides
    );

    return new runtime.JSONApiResponse(response, (jsonValue) =>
      TransactionDtoFromJSON(jsonValue)
    );
  }

  /**
   * Returns a single transaction
   * Find transaction by ID
   */
  async findById(
    requestParameters: PacsTransactionsControllerImplApiFindByIdRequest,
    initOverrides?: RequestInit | runtime.InitOverideFunction
  ): Promise<TransactionDto> {
    const response = await this.findByIdRaw(requestParameters, initOverrides);
    return await response.value();
  }

  /**
   * Get paged messages for the transaction matching the given ID
   * Get paged messages for a transaction
   */
  async findMessagesByTxIdRaw(
    requestParameters: PacsTransactionsControllerImplApiFindMessagesByTxIdRequest,
    initOverrides?: RequestInit | runtime.InitOverideFunction
  ): Promise<runtime.ApiResponse<PageTransactionMessage>> {
    if (
      requestParameters.transactionId === null ||
      requestParameters.transactionId === undefined
    ) {
      throw new runtime.RequiredError(
        'transactionId',
        'Required parameter requestParameters.transactionId was null or undefined when calling findMessagesByTxId.'
      );
    }

    const queryParameters: any = {};

    if (requestParameters.filter !== undefined) {
      queryParameters['filter'] = requestParameters.filter;
    }

    if (requestParameters.pn !== undefined) {
      queryParameters['pn'] = requestParameters.pn;
    }

    if (requestParameters.ps !== undefined) {
      queryParameters['ps'] = requestParameters.ps;
    }

    if (requestParameters.sort !== undefined) {
      queryParameters['sort'] = requestParameters.sort;
    }

    if (requestParameters.direction !== undefined) {
      queryParameters['direction'] = requestParameters.direction;
    }

    const headerParameters: runtime.HTTPHeaders = {};

    const response = await this.request(
      {
        path: `/api/gateway/iso20022/transactions/{transactionId}/messages`.replace(
          `{${'transactionId'}}`,
          encodeURIComponent(String(requestParameters.transactionId))
        ),
        method: 'GET',
        headers: headerParameters,
        query: queryParameters,
      },
      initOverrides
    );

    return new runtime.JSONApiResponse(response, (jsonValue) =>
      PageTransactionMessageFromJSON(jsonValue)
    );
  }

  /**
   * Get paged messages for the transaction matching the given ID
   * Get paged messages for a transaction
   */
  async findMessagesByTxId(
    requestParameters: PacsTransactionsControllerImplApiFindMessagesByTxIdRequest,
    initOverrides?: RequestInit | runtime.InitOverideFunction
  ): Promise<PageTransactionMessage> {
    const response = await this.findMessagesByTxIdRaw(
      requestParameters,
      initOverrides
    );
    return await response.value();
  }

  /**
   * Returns a transactions page
   * Find transactions
   */
  async findUnapprovedRaw(
    initOverrides?: RequestInit | runtime.InitOverideFunction
  ): Promise<runtime.ApiResponse<CountResponse>> {
    const queryParameters: any = {};

    const headerParameters: runtime.HTTPHeaders = {};

    const response = await this.request(
      {
        path: `/api/gateway/iso20022/transactions/unapproved/count`,
        method: 'GET',
        headers: headerParameters,
        query: queryParameters,
      },
      initOverrides
    );

    return new runtime.JSONApiResponse(response, (jsonValue) =>
      CountResponseFromJSON(jsonValue)
    );
  }

  /**
   * Returns a transactions page
   * Find transactions
   */
  async findUnapproved(
    initOverrides?: RequestInit | runtime.InitOverideFunction
  ): Promise<CountResponse> {
    const response = await this.findUnapprovedRaw(initOverrides);
    return await response.value();
  }

  /**
   * Get transaction metrics
   */
  async getAllMetricsRaw(
    initOverrides?: RequestInit | runtime.InitOverideFunction
  ): Promise<runtime.ApiResponse<TransactionAllMetrics>> {
    const queryParameters: any = {};

    const headerParameters: runtime.HTTPHeaders = {};

    const response = await this.request(
      {
        path: `/api/gateway/iso20022/transaction-metrics`,
        method: 'GET',
        headers: headerParameters,
        query: queryParameters,
      },
      initOverrides
    );

    return new runtime.JSONApiResponse(response, (jsonValue) =>
      TransactionAllMetricsFromJSON(jsonValue)
    );
  }

  /**
   * Get transaction metrics
   */
  async getAllMetrics(
    initOverrides?: RequestInit | runtime.InitOverideFunction
  ): Promise<TransactionAllMetrics> {
    const response = await this.getAllMetricsRaw(initOverrides);
    return await response.value();
  }

  /**
   * Returns a single transaction
   * Find the raw XML content for transaction message by ID
   */
  async getRawMessageByIdRaw(
    requestParameters: PacsTransactionsControllerImplApiGetRawMessageByIdRequest,
    initOverrides?: RequestInit | runtime.InitOverideFunction
  ): Promise<runtime.ApiResponse<string>> {
    if (
      requestParameters.transactionMessageId === null ||
      requestParameters.transactionMessageId === undefined
    ) {
      throw new runtime.RequiredError(
        'transactionMessageId',
        'Required parameter requestParameters.transactionMessageId was null or undefined when calling getRawMessageById.'
      );
    }

    const queryParameters: any = {};

    const headerParameters: runtime.HTTPHeaders = {};

    const response = await this.request(
      {
        path: `/api/gateway/iso20022/transaction-messages/{transactionMessageId}/raw`.replace(
          `{${'transactionMessageId'}}`,
          encodeURIComponent(String(requestParameters.transactionMessageId))
        ),
        method: 'GET',
        headers: headerParameters,
        query: queryParameters,
      },
      initOverrides
    );

    return new runtime.TextApiResponse(response) as any;
  }

  /**
   * Returns a single transaction
   * Find the raw XML content for transaction message by ID
   */
  async getRawMessageById(
    requestParameters: PacsTransactionsControllerImplApiGetRawMessageByIdRequest,
    initOverrides?: RequestInit | runtime.InitOverideFunction
  ): Promise<string> {
    const response = await this.getRawMessageByIdRaw(
      requestParameters,
      initOverrides
    );
    return await response.value();
  }

  /**
   * Get the reference data, i.e. currencies, statuses etc.
   * Get the reference data
   */
  async getReferenceDataRaw(
    initOverrides?: RequestInit | runtime.InitOverideFunction
  ): Promise<runtime.ApiResponse<ReferenceDataDto>> {
    const queryParameters: any = {};

    const headerParameters: runtime.HTTPHeaders = {};

    const response = await this.request(
      {
        path: `/api/gateway/iso20022/transaction-options`,
        method: 'GET',
        headers: headerParameters,
        query: queryParameters,
      },
      initOverrides
    );

    return new runtime.JSONApiResponse(response, (jsonValue) =>
      ReferenceDataDtoFromJSON(jsonValue)
    );
  }

  /**
   * Get the reference data, i.e. currencies, statuses etc.
   * Get the reference data
   */
  async getReferenceData(
    initOverrides?: RequestInit | runtime.InitOverideFunction
  ): Promise<ReferenceDataDto> {
    const response = await this.getReferenceDataRaw(initOverrides);
    return await response.value();
  }

  /**
   * Approve or reject a transaction, effectively sending the corresponding PACS message to the counterparty.
   * Approve or reject a transaction.
   */
  async reviewRaw(
    requestParameters: PacsTransactionsControllerImplApiReviewRequest,
    initOverrides?: RequestInit | runtime.InitOverideFunction
  ): Promise<runtime.ApiResponse<object>> {
    if (
      requestParameters.transactionId === null ||
      requestParameters.transactionId === undefined
    ) {
      throw new runtime.RequiredError(
        'transactionId',
        'Required parameter requestParameters.transactionId was null or undefined when calling review.'
      );
    }

    if (
      requestParameters.transactionReviewRequestBody === null ||
      requestParameters.transactionReviewRequestBody === undefined
    ) {
      throw new runtime.RequiredError(
        'transactionReviewRequestBody',
        'Required parameter requestParameters.transactionReviewRequestBody was null or undefined when calling review.'
      );
    }

    const queryParameters: any = {};

    const headerParameters: runtime.HTTPHeaders = {};

    headerParameters['Content-Type'] = 'application/json';

    const response = await this.request(
      {
        path: `/api/gateway/iso20022/transactions/{transactionId}/review`.replace(
          `{${'transactionId'}}`,
          encodeURIComponent(String(requestParameters.transactionId))
        ),
        method: 'POST',
        headers: headerParameters,
        query: queryParameters,
        body: TransactionReviewRequestBodyToJSON(
          requestParameters.transactionReviewRequestBody
        ),
      },
      initOverrides
    );

    return new runtime.JSONApiResponse<any>(response);
  }

  /**
   * Approve or reject a transaction, effectively sending the corresponding PACS message to the counterparty.
   * Approve or reject a transaction.
   */
  async review(
    requestParameters: PacsTransactionsControllerImplApiReviewRequest,
    initOverrides?: RequestInit | runtime.InitOverideFunction
  ): Promise<object> {
    const response = await this.reviewRaw(requestParameters, initOverrides);
    return await response.value();
  }

  /**
   * Approve or reject transactions, effectively sending the corresponding PACS message to the counterparty.
   * Approve or reject transactions.
   */
  async review1Raw(
    requestParameters: PacsTransactionsControllerImplApiReview1Request,
    initOverrides?: RequestInit | runtime.InitOverideFunction
  ): Promise<runtime.ApiResponse<TransactionsReviewResponse>> {
    if (
      requestParameters.transactionsReviewRequestBody === null ||
      requestParameters.transactionsReviewRequestBody === undefined
    ) {
      throw new runtime.RequiredError(
        'transactionsReviewRequestBody',
        'Required parameter requestParameters.transactionsReviewRequestBody was null or undefined when calling review1.'
      );
    }

    const queryParameters: any = {};

    const headerParameters: runtime.HTTPHeaders = {};

    headerParameters['Content-Type'] = 'application/json';

    const response = await this.request(
      {
        path: `/api/gateway/iso20022/review`,
        method: 'POST',
        headers: headerParameters,
        query: queryParameters,
        body: TransactionsReviewRequestBodyToJSON(
          requestParameters.transactionsReviewRequestBody
        ),
      },
      initOverrides
    );

    return new runtime.JSONApiResponse(response, (jsonValue) =>
      TransactionsReviewResponseFromJSON(jsonValue)
    );
  }

  /**
   * Approve or reject transactions, effectively sending the corresponding PACS message to the counterparty.
   * Approve or reject transactions.
   */
  async review1(
    requestParameters: PacsTransactionsControllerImplApiReview1Request,
    initOverrides?: RequestInit | runtime.InitOverideFunction
  ): Promise<TransactionsReviewResponse> {
    const response = await this.review1Raw(requestParameters, initOverrides);
    return await response.value();
  }
}

/**
 * @export
 */
export const FindDirectionEnum = {
  Asc: 'ASC',
  Desc: 'DESC',
} as const;
export type FindDirectionEnum =
  typeof FindDirectionEnum[keyof typeof FindDirectionEnum];
/**
 * @export
 */
export const FindMessagesByTxIdDirectionEnum = {
  Asc: 'ASC',
  Desc: 'DESC',
} as const;
export type FindMessagesByTxIdDirectionEnum =
  typeof FindMessagesByTxIdDirectionEnum[keyof typeof FindMessagesByTxIdDirectionEnum];
